include (jslib_dir);
include (jslib_fileutils);
include (jslib_file);
include ("chrome://mozimage/content/mozimage_prefs.js");
include ("chrome://global/content/strres.js");

/*
**
** Private function
**
*/

var mozImageBundle = srGetStrBundle("chrome://mozimage/locale/mozimage.properties");
var modImageLastImage = '';

setTimeout(window_load, 100);

function showFile(imageURL)
{
  var mainImage = document.getElementById("main-image");

  mainImage.removeAttribute('width');
  mainImage.removeAttribute('height');
  mainImage.src = imageURL;

  var imageBox = document.getElementById("image-box");
  if (prefs.getAutoSize())
    imageBox.setAttribute("class", "noscroll");
  else
    imageBox.setAttribute("class", "scroll");
}

function resize(ratio)
{
  var image = document.getElementById("main-image");
  var filename = image.src;
  var newWidth = image.boxObject.width * ratio;
  var newHeight = image.boxObject.height * ratio;
  
  if (prefs.getAutoSize())
    autosize_click();
  
  image.src = "";
  image.width = newWidth;
  image.height = newHeight;
  image.src = filename;
}

function autoSize()
{
  var image = document.getElementById("main-image");
  // avoid an infinite loop
  if (modImageLastImage != image.src) 
  {
    modImageLastImage = image.src;
    var newImage = new Image();
    newImage.setAttribute("id", "thepreviewimage");
    newImage.src = image.src;
    var box = document.getElementById("image-box");
    var boxWidth = box.boxObject.width;
    var boxHeight = box.boxObject.height;
    var filename = image.src;
    var xratio = newImage.width / boxWidth;
    var yratio = newImage.height / boxHeight;
    var ratio = (xratio > yratio) ? xratio : yratio;
  
    image.src = "";
    image.width = newImage.width / ratio;
    image.height = newImage.height / ratio;
    image.src = filename;
  }
}

function updateDescription()
{
  var image = document.getElementById("main-image");
  var info = document.getElementById("info-label");
  var newImage = new Image();
  newImage.setAttribute("id", "thepreviewimage");
  newImage.src = image.src;
  info.value = mozImageBundle.formatStringFromName("sizeInfo", [newImage.width, newImage.height], 2);
}

function fillListBox(adir)
{
  var dirlistbox = document.getElementById("directory-listbox");
  var filelistbox = document.getElementById("file-listbox");
  var d = new Dir(adir);
  var dirList = d.readDir();
  var fullpath = document.getElementById("fullpath-text");

  var dirs = new Array();
  var files = new Array();
  
  emptyList();
  fullpath.value = adir;


  for (var i = 0 ; i < dirList.length ; i++) 
    dirList[i].isDir() ?  dirs.push(dirList[i]) : files.push(dirList[i]);

  dirs.sort();
  files.sort();

  dirList = new Array();

  for (var i = 0 ; i < dirs.length ; i++)
  {
    var listItem = dirlistbox.appendItem(dirs[i].leaf, '');
    // add the attributes to show right icon
    listItem.setAttribute("class", "listitem-iconic");
    listItem.setAttribute("value", "directory");
  }

  for (var i = 0 ; i < files.length ; i++)
    if (supportedType(files[i]))
      filelistbox.appendItem(files[i].leaf, '');
    
  prefs.setHomeDir(adir);
   
}

function supportedType(file)
{
  var result = false;
  var extList = prefs.getExtList();
  for (var i = 0 ; i < extList.length ; i++)
  {
    if (extList[i].toUpperCase() == file.ext.toUpperCase())
      result = true;
  }    
  return(result);
}

function emptyList()
{
  var dirlistbox = document.getElementById("directory-listbox");
  var filelistbox = document.getElementById("file-listbox");
  var item;
  
  var i = dirlistbox.getRowCount();
  while (i > 0)
  {
    i--;
    item = dirlistbox.getItemAtIndex(i);
    dirlistbox.removeChild(item);
  }
  i = filelistbox.getRowCount();
  while (i > 0)
  {
    i--;
    item = filelistbox.getItemAtIndex(i);
    filelistbox.removeChild(item);
  }

}

function doSlideShow()
{
  var slideShowMenu = document.getElementById("slideshow-menu");
  // check between string because with boolean doesn't work
  if ( slideShowMenu.getAttribute("checked") == "true" )
  {
    next_click();
    setTimeout(doSlideShow, prefs.getDelay());
  }
}

function selectItemByName(itemName)
{
  var fileListBox = document.getElementById("file-listbox");
  var numOfRows = fileListBox.getRowCount();
  
  for(var i = 0 ; i < numOfRows ; i++)
  {
    item = fileListBox.getItemAtIndex(i);
    fileListBox.scrollToIndex(i);
    if ( item.label == itemName )
    {
      fileListBox.selectItem(item);
    }

  }
  fileListBox.ensureIndexIsVisible(fileListBox.selectedIndex);
}

function parseCommandLine()
{
  var cmdLineService = Components.classes["@mozilla.org/appshell/commandLineService;1" ].getService( Components.interfaces.nsICmdLineService );
  var path = cmdLineService.URLToLoad;

  if (path != null && path != "")
  {
    var file = new File(path);
    if (file.isDir())
      fillListBox(file.path)
    else
    {
      fillListBox(file.parent.path);
      selectItemByName(file.leaf);
    }
  }
}


/*
**
** Event handler
**
*/

function window_load(event)
{
  var fullpath = document.getElementById("fullpath-text");
  var autoSizeMenu = document.getElementById("autosize-menu");
  var autoSizeButton = document.getElementById("autosize-button");
  autoSizeMenu.setAttribute("checked", prefs.getAutoSize());
  autoSizeButton.setAttribute("checked", prefs.getAutoSize());

  window.screenX = prefs.getLeft();
  window.screenY = prefs.getTop();
  window.outerWidth = prefs.getWidth();
  window.outerHeight = prefs.getHeight();

  window.onresize = image_resize;
  parseCommandLine();
  if (fullpath.value == "")
    fillListBox(prefs.getHomeDir());
}

function window_close(event)
{
  prefs.setLeft(window.screenX);
  prefs.setTop(window.screenY);
  prefs.setWidth(window.outerWidth);
  prefs.setHeight(window.outerHeight);
  prefs.save();
}

function about_click()
{
  window.openDialog('chrome://mozimage/content/mozimage_about.xul', 'about', 'chrome,centerscreen,dialog,modal');
}

function options_click()
{
  prefs.save();
  window.openDialog('chrome://mozimage/content/mozimage_prefs.xul', mozImageBundle.GetStringFromName("optionsTitle"), 'chrome,centerscreen,dialog,modal');
  prefs.load();
}

function exit_click()
{
  window.close();
}

function image_resize()
{
  var mainImage = document.getElementById("main-image");
  if (prefs.getAutoSize() && mainImage.src != "")
  {
    modImageLastImage = '';
    autoSize();
  }
}

function autosize_click()
{
  var mainImage = document.getElementById("main-image");
  var autoSizeMenu = document.getElementById("autosize-menu");
  var autoSizeButton = document.getElementById("autosize-button");
  var autosize = !prefs.getAutoSize();
  
  prefs.setAutoSize(autosize);
  autoSizeMenu.setAttribute('checked', autosize);
  autoSizeButton.setAttribute('checked', autosize);
  
  // Reload the image to adjust the size based on the
  // "autosize" setting
  showFile(mainImage.src);
}

function zoomout_click()
{
  resize(1/2);
}

function zoomin_click()
{
  resize(2);
}

function slideshow_click()
{
  doSlideShow();
}

function image_click()
{
  var image = document.getElementById("main-image");
  image.focus();
}

function image_load()
{
  if (prefs.getAutoSize())
    autoSize();
  updateDescription();
}

function clear_click()
{
  // Clear image
  var image = document.getElementById("main-image");
  image.src = "";
  image.width = 0;
  image.height = 0;
  // and stop slide show
  var slideShowMenu = document.getElementById("slideshow-menu");
  slideShowMenu.setAttribute("checked", "false");
}

function prior_click()
{
  var fileListBox = document.getElementById("file-listbox");
  var selectedIndex = fileListBox.selectedIndex;
  if (selectedIndex >= 1)
    fileListBox.selectedIndex = selectedIndex - 1;
  else
    fileListBox.selectedIndex =  fileListBox.getRowCount() - 1;
  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );
}

function next_click()
{
  var fileListBox = document.getElementById("file-listbox");
  var selectedIndex = fileListBox.selectedIndex;
  if (selectedIndex >= -1 && selectedIndex < fileListBox.getRowCount() - 1)
    fileListBox.selectedIndex = selectedIndex + 1;
  else
    fileListBox.selectedIndex = 0;
  fileListBox.ensureIndexIsVisible ( fileListBox.selectedIndex );
}

function up_click()
{
  var fullpath = document.getElementById("fullpath-text");
  var fileUtil = new FileUtils();
  if (fullpath.value)
  {
    var aPath = fullpath.value;
    var file = new File(aPath);
    var aParent = file.parent.path;
    fillListBox(aParent);
  }
}

function go_click(event)
{
  var fullpath = document.getElementById("fullpath-text");
  fillListBox(fullpath.value);
}

function directory_select(event)
{
  var selectedItem = event.target.selectedItem;
  var basePath = document.getElementById("fullpath-text");
  var path = selectedItem.getAttribute("label");
  var fileUtil = new FileUtils();

  fillListBox(fileUtil.append(basePath.value, path));
}

function file_select(event)
{
  var selectedItem = event.target.selectedItem;
  var basePath = document.getElementById("fullpath-text");
  var fileUtil = new FileUtils();

  showFile('file:///' + fileUtil.append(basePath.value, selectedItem.label));
}
